﻿
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  #LIBTURBO_PROCESSOR = "64"
CompilerElse
  #LIBTURBO_PROCESSOR = "32"
CompilerEndIf

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    #LIBTURBO = "turbojpeg-static_win" + #LIBTURBO_PROCESSOR + ".lib"
  CompilerCase #PB_OS_MacOS
    #LIBTURBO = "libturbojpeg_osx.a"
  CompilerCase #PB_OS_Linux
    #LIBTURBO = "libturbojpeg_lin" + #LIBTURBO_PROCESSOR + ".a"
CompilerEndSelect

Enumeration
  #TJPF_RGB    
  #TJPF_BGR    
  #TJPF_RGBX    
  #TJPF_BGRX
  #TJPF_XBGR
  #TJPF_XRGB
  #TJPF_GRAY
  #TJPF_RGBA
  #TJPF_BGRA
EndEnumeration

Enumeration
  #TJSAMP_444    
  #TJSAMP_422    
  #TJSAMP_420    
EndEnumeration

#TJFLAG_BOTTOMUP    = 2
#TJFLAG_FASTDCT     = 2048
#TJFLAG_ACCURATEDCT = 4096

ImportC #LIBTURBO
  tjAlloc(bytes)
  tjCompress2.l(handle, *srcBuf, width, pitch, height, pixelFormat, *p_jpegBuf, *jpegSize, jpegSubsamp, jpegQual, flags)
  tjDecompress2.l(handle, *jpegBuf, jpegSize, *dstBuf, width, pitch, height, pixelFormat, flags)
  tjDecompressHeader3.l(handle, *jpegBuf, jpegSize, *width, *height, *jpegSubsamp, *jpegColorspace)
  tjFree(*buffer)
  tjGetErrorStr()   
  tjInitCompress()
  tjInitDecompress()
EndImport

; generate image data

Dim ImageData.l(255, 255)

For y = 0 To 255
  For x = 0 To 255
    ImageData(y, x) = x << 16 | y << 8 | (x ! y)
  Next
Next

; write jpeg file

tjC = tjInitCompress()

*buffer = 0
If tjCompress2(tjC, @ImageData(), 256, 1024, 256, #TJPF_RGBX, @*buffer, @size, #TJSAMP_444, 95, #TJFLAG_ACCURATEDCT) = 0
  If CreateFile(0, "libturbojpeg_test.jpg")
    WriteData(0, *buffer, size)
    CloseFile(0)
  EndIf
  tjFree(*buffer)
EndIf
; IDE Options = PureBasic 5.42 LTS (MacOS X - x64)
; CursorPosition = 18
; Folding = -
; EnableUnicode
; EnableThread
; EnableXP
; CompileSourceDirectory